-----DEBUG CONTROL--------------------------------------------------------------

debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value).."\n")
  end
end


-- NoIndex: true

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--

--------------------------------
 --REATRAK LOCAL GUI LIBRARY start
--------------------------------
local info = debug.getinfo(1,'S');
script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]

if not reaper.file_exists( script_path .. "ahk\\AutoHotkey.exe" ) then

  script_path = "C:\\Program Files\\AutoHotkey\\"  
else

  script_path = script_path .. "ahk\\"
end

--Msg("Path "..script_path)
--Msg("script_path "..script_path)
--local lib_path = script_path --reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
--if not lib_path or lib_path == "" then
    --reaper.MB("Couldn't load the ReaTrak Lokasenna_GUI library. Please check Scripts/ReaTrak/ReaTrak_Classes/", "Whoops!", 0)
    --return
--end
--[[
loadfile(script_path .. "ReaTrak_Core.lua")()

GUI.req(script_path .. "ReaTrak_Classes/Class - Label.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Knob.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Tabs.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Slider.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Button.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Menubox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Textbox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Frame.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Options.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Window.lua")()

--------------------------------
 --REATRAK LOCAL GUI LIBRARY end
--------------------------------

--]]
--------------------------------
 --LOKASENNA GUI LIBRARY start
--------------------------------

-- NoIndex: true

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--



-- The Core library must be loaded prior to anything else
--reaper.MB("Using Lokasenna_GUI library", "Notice", 0)
    
local lib_path = reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
if not lib_path or lib_path == "" then
    reaper.MB("Couldn't load the Lokasenna_GUI library. Please run 'Script: Set Lokasenna_GUI v2 library path.lua' in your Action List.", "Whoops!", 0)
    return
end
loadfile(lib_path .. "Core.lua")()

GUI.req("Classes/Class - Label.lua")()
GUI.req("Classes/Class - Knob.lua")()
GUI.req("Classes/Class - Tabs.lua")()
GUI.req("Classes/Class - Slider.lua")()
GUI.req("Classes/Class - Button.lua")()
GUI.req("Classes/Class - Menubox.lua")()
GUI.req("Classes/Class - Textbox.lua")()
GUI.req("Classes/Class - Frame.lua")()
GUI.req("Classes/Class - Options.lua")()
GUI.req("Classes/Class - Window.lua")()

--------------------------------
 --LOKASENNA GUI LIBRARY end
--------------------------------


-- If any of the requested libraries weren't found, abort the script nicely.
if missing_lib then return 0 end


-- Button Colors  = {r, g, b, transparency}

GUI.colors["count_in"] = {255, 124, 192, 255}
GUI.colors["intro_post_fill"] = {119, 17, 174, 255}
GUI.colors["intro"] = {159, 22, 232, 255}
GUI.colors["intro_fill"] = {183, 128, 237, 255}
GUI.colors["verse_post_fill"] = {17, 39, 174, 255}
GUI.colors["verse"] = {55, 118, 235, 255}
GUI.colors["verse_fill"] = {113, 190, 241, 255}
GUI.colors["verse_ending"] = {151, 208, 245, 255}
GUI.colors["bridge_post_fill"] = {206, 105, 20, 255}
GUI.colors["bridge"] = {234, 133, 48, 255}
GUI.colors["bridge_fill"] = {239, 164, 100, 255}
GUI.colors["pre_chorus_post_fill"] = {206, 179, 20, 255}
GUI.colors["pre_chorus"] = {234, 208, 48, 255}
GUI.colors["pre_chorus_fill"] = {244, 231, 151, 255}
GUI.colors["chorus_post_fill"] = {11, 116, 39, 255}
GUI.colors["chorus"] = {17, 174, 59, 255}
GUI.colors["chorus_fill"] = {80, 237, 123, 255}
GUI.colors["chorus_ending"] = {158, 254, 182, 255}
GUI.colors["play_anywhere"] = {228, 26, 39, 250}
GUI.colors["drum_riff"] = {115, 23, 17, 255}
GUI.colors["hold"] = {191, 191, 191, 255}
GUI.colors["shot"] = {127, 127, 127, 255}
GUI.colors["rest"] = {0, 0, 0, 255}
GUI.colors["stop"] = {151, 0, 75, 255}



--Text Colors

GUI.colors["btn_txt1"] = {255, 255, 255, 255} --white
GUI.colors["btn_txt2"] = {155, 155, 155, 255} --gray
GUI.colors["btn_txt3"] = {0, 0, 0, 255} --black

------------------------------------
-------- Functions  ----------------
------------------------------------
a = 0


local function btn_click()
  
  -- Grab all of the user's settings into local variables,
  -- just to make it less awkward to work with
  local mode, thresh = GUI.Val("mnu_mode"), GUI.Val("sldr_thresh")
  local opts = GUI.Val("chk_opts")
  local time_sel, sel_track, glue = opts[1], opts[2], opts[3]
  
  -- Be nice, give the user an Undo point
  reaper.Undo_BeginBlock()
  
  reaper.ShowMessageBox(
    "This is where we pretend to perform some sort of fancy operation with the user's settings.\n\n"
    .."Working in "..tostring(GUI.elms.mnu_mode.optarray[mode])
    .." mode with a threshold of "..tostring(thresh).."db.\n\n"
    .."Apply only to time selection: "..tostring(time_sel).."\n"
    .."Apply only to selected track: "..tostring(sel_track).."\n"
    .."Glue the processed items together afterward: "..tostring(glue)
  , "Yay!", 0)
  
  
  reaper.Undo_EndBlock("Typical script options", 0)     
  
  -- Exit the script on the next update
  GUI.quit = true
  
end

function btn_click_play()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/play.ahk"]],-2)

end

function btn_play_from()

  cur_pos =  reaper.GetCursorPosition()
  retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, cur_pos )
  qn = reaper.TimeMap_timeToQN_abs( 0, cur_pos )
  --retval, qn_start, qn_end, timesig_num, timesig_denom, tempo = reaper.TimeMap_GetMeasureInfo( 0, measure )
  retval, qnMeasureStart, qnMeasureEnd = reaper.TimeMap_QNToMeasures( 0, qn )
  
  --Msg("measures "..measures)
  reaper.CF_SetClipboard( math.floor(measures-1) )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/play_from.ahk]],-2)
  
end  

function btn_set_countin()

  reaper.SNM_SetIntConfigVar('projmeasoffs', -2) -- Play to next project region after current region
  reaper.UpdateTimeline()
end

function btn_play_bb_loop()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/play_bb_loop.ahk]],-2)
end

function btn_play_start()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/play_start.ahk]],-2)
end

function btn_play_reaper_loop()

  cur_pos =  reaper.GetCursorPosition()
  loop_start, loop_end = reaper.GetSet_LoopTimeRange2( 0, false, false, 0, 0, 0 )
  retval, start_measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, loop_start )
  retval, end_measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, loop_end )
  start_measures = math.floor(start_measures-1)
  end_measures = math.floor(end_measures-1)
  number_measures = tonumber(end_measures) - tonumber(start_measures)
  reaper.CF_SetClipboard( start_measures ..",".. number_measures )
  --Msg(reaper.CF_GetClipboard())
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/play_reaper_loop.ahk]],-2)
end

function btn_stop()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/stop.ahk]],-2)

end

function btn_bb_save()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/bb_save.ahk]],-2)
end

function btn_bb_save_as()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/bb_save_as.ahk]],-2)
end

function btn_reaper_save()

  reaper.Main_OnCommand( 40026, 0 ) -- File: Save project
end

function btn_reaper_save_as()

  reaper.Main_OnCommand( 40022, 0 ) -- File: Save project as...
end

function btn_clear_bb_loop()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/clear_loop.ahk]],-2)
end

function btn_clear_repaer_loop()
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/clear_loop.ahk]],-2)
  reaper.Main_OnCommand( 40020, 0 ) -- Time selection: Remove time selection and loop points
end

function SetLoopTimeSelection()
  MeasOffset = reaper.SNM_GetIntConfigVar('projmeasoffs', 0)
  StartLoopTime = reaper.TimeMap2_beatsToTime(0, 0, LoopFirstBar -1 - MeasOffset)
  EndLoopTime = reaper.TimeMap2_beatsToTime(0, 0, LoopFirstBar -1 -MeasOffset +BarsToLoop)
  reaper.GetSet_LoopTimeRange(true, true, StartLoopTime, EndLoopTime, true)

  _, num_markers,num_regions = reaper.CountProjectMarkers(0)
  LoopRegionName = "looping Bars "..tostring(LoopFirstBar).." thru "..tostring(LoopFirstBar+BarsToLoop-1)
  newRegion = reaper.AddProjectMarker(0, true, StartLoopTime, EndLoopTime, LoopRegionName, num_regions+1)
end

function wait(time)
    local duration = os.time() + time
    while os.time() < duration do end
end

function btn_copy_bb_tempo()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/copy_bb_tempo.ahk]],-2)
  wait(3)
  text_tempo = reaper.CF_GetClipboard()
  
  --Msg("Tempo "..text_tempo)
  bpm = tonumber(text_tempo)
  reaper.SNM_SetIntConfigVar("projbpm",bpm)
  reaper.SetEditCurPos2( 0, 0, 0, 0 )
  reaper.SetCurrentBPM( 0, bpm, true )
  
end

function btn_reaper_rewire()

  reaper.MB( "Set Rewire Settings to Ignore tempo map...", "Set Rewire Info", 0 )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/reaper_rewire.ahk]],-2)
end

function btn_import_sgu()

  
  
  rootNames = { "C", "Db", "D", "Eb", "E", "F", "Gb", "G", "Ab", "A", "Bb", "B", "C#", "D#", "F#", "G#", "A#" }
  
  --pad the rest of rootNames with ? for unknown types
  for j = 18,26 do 
    rootNames[j] = "?"
  end
  --add in any unusual chord types
  
  rootNames[27] ="Ab/A"
  rootNames[28] ="A/Bb"
  rootNames[29] ="Bb/B"
  rootNames[30] ="B/C"
  rootNames[31] ="C#/Db"
  rootNames[32] ="D#/D"
  rootNames[33] ="F#/Eb"
  rootNames[34] ="G#/E"
  rootNames[35] ="A#/F"
  rootNames[36] ="A#/Db"
  rootNames[37] ="C/D"
  rootNames[38] ="Db/Eb"
  rootNames[39] ="D/E"
  rootNames[40] ="Eb/F"
  rootNames[41] ="E/Gb"
  rootNames[42] ="F/G"
  rootNames[43] ="Gb/Ab"
  rootNames[44] ="G/A"
  rootNames[45] ="Ab/Bb"
  rootNames[46] ="A/B"
  rootNames[47] ="Bb/C"
  rootNames[48] ="B/Db"
  rootNames[49] ="C#/D"
  rootNames[50] ="D#/Eb"
  rootNames[51] ="F#/E"
  rootNames[52] ="G#/F"
  rootNames[53] ="A#/Gb"
  rootNames[54] ="A#/D"
  rootNames[55] ="C/Eb"
  rootNames[56] ="Db/E"
  rootNames[57] ="D/F"
  rootNames[58] ="Eb/Gb"
  rootNames[59] ="E/G"
  rootNames[60] ="F/Ab"
  rootNames[61] ="Gb/A"
  rootNames[62] ="G/Bb"
  rootNames[63] ="Ab/B"
  rootNames[64] ="A/C"
  rootNames[65] ="Bb/Db"
  rootNames[66] ="B/D"
  rootNames[67] ="C#/Eb"
  rootNames[68] ="D#/E"
  rootNames[69] ="F#/F"
  rootNames[70] ="G#/Gb"
  rootNames[71] ="A#/G"
  rootNames[72] ="A#/Eb"
  rootNames[73] ="C/E"
  rootNames[74] ="Db/F"
  rootNames[75] ="D/Gb"
  rootNames[76] ="Eb/G"
  rootNames[77] ="E/Ab"
  rootNames[78] ="F/A"
  rootNames[79] ="Gb/Bb"
  rootNames[80] ="G/B"
  rootNames[81] ="Ab/C"
  rootNames[82] ="A/Db"
  rootNames[83] ="Bb/D"
  rootNames[84] ="B/Eb"
  rootNames[85] ="C#/E"
  rootNames[86] ="D#/F"
  rootNames[87] ="F#/Gb"
  rootNames[88] ="G#/G"
  rootNames[89] ="A#/Ab"
  rootNames[90] ="A#/E"
  rootNames[91] ="C/F"
  rootNames[92] ="Db/Gb"
  rootNames[93] ="D/G"
  rootNames[94] ="Eb/Ab"
  rootNames[95] ="E/A"
  rootNames[96] ="F/Bb"
  rootNames[97] ="Gb/B"
  rootNames[98] ="G/C"
  rootNames[99] ="Ab/Db"
  rootNames[100] ="A/D"
  rootNames[101] ="Bb/Eb"
  rootNames[102] ="B/E"
  rootNames[103] ="C#/F"
  rootNames[104] ="D#/Gb"
  rootNames[105] ="F#/G"
  rootNames[106] ="G#/Ab"
  rootNames[107] ="A#/A"
  rootNames[108] ="A#/F"
  rootNames[109] ="C/Gb"
  rootNames[110] ="Db/G"
  rootNames[111] ="D/Ab"
  rootNames[112] ="Eb/A"
  rootNames[113] ="E/Bb"
  rootNames[114] ="F/B"
  rootNames[115] ="Gb/C"
  rootNames[116] ="G/Db"
  rootNames[117] ="Ab/D"
  rootNames[118] ="A/Eb"
  rootNames[119] ="Bb/E"
  rootNames[120] ="B/F"
  rootNames[121] ="C#/Gb"
  rootNames[122] ="D#/G"
  rootNames[123] ="F#/Ab"
  rootNames[124] ="G#/A"
  rootNames[125] ="A#/Bb"
  rootNames[126] ="A#/Gb"
  rootNames[127] ="C/G"
  rootNames[128] ="Db/Ab"
  rootNames[129] ="D/A"
  rootNames[130] ="Eb/Bb"
  rootNames[131] ="E/B"
  rootNames[132] ="F/C"
  rootNames[133] ="Gb/Db"
  rootNames[134] ="G/D"
  rootNames[135] ="Ab/Eb"
  rootNames[136] ="A/E"
  rootNames[137] ="Bb/F"
  rootNames[138] ="B/Gb"
  rootNames[139] ="C#/G"
  rootNames[140] ="D#/Ab"
  rootNames[141] ="F#/A"
  rootNames[142] ="G#/Bb"
  rootNames[143] ="A#/B"
  rootNames[144] ="A#/G"
  rootNames[145] ="C/Ab"
  rootNames[146] ="Db/A"
  rootNames[147] ="D/Bb"
  rootNames[148] ="Eb/B"
  rootNames[149] ="E/C"
  rootNames[150] ="F/Db"
  rootNames[151] ="Gb/D"
  rootNames[152] ="G/Eb"
  rootNames[153] ="Ab/E"
  rootNames[154] ="A/F"
  rootNames[155] ="Bb/Gb"
  rootNames[156] ="B/G"
  rootNames[157] ="C#/Ab"
  rootNames[158] ="D#/A"
  rootNames[159] ="F#/Bb"
  rootNames[160] ="G#/B"
  rootNames[161] ="A#/C"
  rootNames[162] ="A#/Ab"
  rootNames[163] ="C/A"
  rootNames[164] ="Db/Bb"
  rootNames[165] ="D/B"
  rootNames[166] ="Eb/C"
  rootNames[167] ="E/Db"
  rootNames[168] ="F/D"
  rootNames[169] ="Gb/Eb"
  rootNames[170] ="G/E"
  rootNames[171] ="Ab/F"
  rootNames[172] ="A/Gb"
  rootNames[173] ="Bb/G"
  rootNames[174] ="B/Ab"
  rootNames[175] ="C#/A"
  rootNames[176] ="D#/Bb"
  rootNames[177] ="F#/B"
  rootNames[178] ="G#/C"
  rootNames[179] ="A#/Db"
  rootNames[180] ="A#/A"
  rootNames[181] ="C/Bb"
  rootNames[182] ="Db/B"
  rootNames[183] ="D/C"
  rootNames[184] ="Eb/Db"
  rootNames[185] ="E/D"
  rootNames[186] ="F/Eb"
  rootNames[187] ="Gb/E"
  rootNames[188] ="G/F"
  rootNames[189] ="Ab/Gb"
  rootNames[190] ="A/G"
  rootNames[191] ="Bb/Ab"
  rootNames[192] ="B/A"
  rootNames[193] ="C#/Bb"
  rootNames[194] ="D#/B"
  rootNames[195] ="F#/C"
  rootNames[196] ="G#/Db"
  rootNames[197] ="A#/D"
  rootNames[198] ="A#/Bb"
  rootNames[199] ="C/B"
  rootNames[200] ="Db/C"
  rootNames[201] ="D/Db"
  rootNames[202] ="Eb/D"
  rootNames[203] ="E/Eb"
  rootNames[204] ="F/E"
  rootNames[205] ="Gb/F"
  rootNames[206] ="G/Gb"
  rootNames[207] ="Ab/G"
  rootNames[208] ="A/Ab"
  rootNames[209] ="Bb/A"
  rootNames[210] ="B/Bb"
  rootNames[211] ="C#/B"
  rootNames[212] ="D#/C"
  rootNames[213] ="F#/Db"
  rootNames[214] ="G#/D"
  rootNames[215] ="A#/Eb"
  rootNames[216] ="A#/B"
  
  --pad the rest of unknown types with ?
  for j = 217,255 do 
    rootNames[j] = "?"
  end
  
  typeNames = {
    "",  -- 1 
    "Maj",  -- 2 
    "b5",  -- 3 
    "aug",  -- 4 
    "6",  -- 5 
    "Maj7",  -- 6 
    "Maj9",  -- 7 
    "Maj9#11",  -- 8 
    "Maj13#11",  -- 9 
    "Maj13",  -- 10 
    "Maj9(no 3)",  -- 11 
    "+",  -- 12 
    "Maj7#5",  -- 13 
    "69",  -- 14 
    "2",  -- 15 
    "m",  -- 16 
    "maug",  -- 17 
    "mMaj7",  -- 18 
    "m7",  -- 19 
    "m9",  -- 20 
    "m11",  -- 21 
    "m13",  -- 22 
    "m6",  -- 23 
    "m#5",  -- 24 
    "m7#5",  -- 25 
    "?",  -- 26 
    "?",  -- 27 
    "?",  -- 28 
    "?",  -- 29 
    "?",  -- 30 
    "?",  -- 31 
    "m7b5",  -- 32 
    "dim",  -- 33 
    "?",  -- 34 
    "?",  -- 35 
    "?",  -- 36 
    "?",  -- 37 
    "?",  -- 38 
    "?",  -- 39 
    "5",  -- 40 
    "?",  -- 41 
    "?",  -- 42 
    "?",  -- 43 
    "?",  -- 44 
    "?",  -- 45 
    "?",  -- 46 
    "?",  -- 47 
    "?",  -- 48 
    "?",  -- 49 
    "?",  -- 50 
    "?",  -- 51 
    "?",  -- 52 
    "?",  -- 53 
    "?",  -- 54 
    "?",  -- 55 
    "7+",  -- 56 
    "9+",  -- 57 
    "13+",  -- 58 
    "?",  -- 59 
    "?",  -- 60 
    "?",  -- 61 
    "?",  -- 62 
    "?",  -- 63 
    "7",  -- 64 
    "13",  -- 65 
    "7b13",  -- 66 
    "7#11",  -- 67 
    "13#11",  -- 68 
    "7#11b13",  -- 69 
    "9",  -- 70 
    "?",  -- 71 
    "9b13",  -- 72 
    "9#11",  -- 73 
    "13#11",  -- 74 
    "9#11b13",  -- 75 
    "7b9",  -- 76 
    "13b9",  -- 77 
    "7b9b13",  -- 78 
    "7b9#11",  -- 79 
    "13b9#11",  -- 80 
    "7b9#11b13",  -- 81 
    "7#9",  -- 82 
    "13#9",  -- 83 
    "7#9b13",  -- 84 
    "9#11",  -- 85 
    "13#9#11",  -- 86 
    "7#9#11b13",  -- 87 
    "7b5",  -- 88 
    "13b5",  -- 89 
    "7b5b13",  -- 90 
    "9b5",  -- 91 
    "9b5b13",  -- 92 
    "7b5b9",  -- 93 
    "13b5b9",  -- 94 
    "7b5b9b13",  -- 95 
    "7b5#9",  -- 96 
    "13b5#9",  -- 97 
    "7b5#9b13",  -- 98 
    "7#5",  -- 99 
    "13#5",  -- 100 
    "7#5#11",  -- 101 
    "13#5#11",  -- 102 
    "9#5",  -- 103 
    "9#5#11",  -- 104 
    "7#5b9",  -- 105 
    "13#5b9",  -- 106 
    "7#5b9#11",  -- 107 
    "13#5b9#11",  -- 108 
    "7#5#9",  -- 109 
    "13#5#9#11",  -- 110 
    "7#5#9#11",  -- 111 
    "13#5#9#11",  -- 112 
    "7alt",  -- 113 
    "?",  -- 114 
    "?",  -- 115 
    "?",  -- 116 
    "?",  -- 117 
    "?",  -- 118 
    "?",  -- 119 
    "?",  -- 120 
    "?",  -- 121 
    "?",  -- 122 
    "?",  -- 123 
    "?",  -- 124 
    "?",  -- 125 
    "?",  -- 126 
    "?",  -- 127 
    "7sus",  -- 128 
    "13sus",  -- 129 
    "7susb13",  -- 130 
    "7sus#11",  -- 131 
    "13sus#11",  -- 132 
    "7sus#11b13",  -- 133 
    "9sus",  -- 134 
    "?",  -- 135 
    "9susb13",  -- 136 
    "9sus#11",  -- 137 
    "13sus#11",  -- 138 
    "9sus#11b13",  -- 139 
    "7susb9",  -- 140 
    "13susb9",  -- 141 
    "7susb913",  -- 142 
    "7susb9#11",  -- 143 
    "13susb9#11",  -- 144 
    "7susb9#11b13",  -- 145 
    "7sus#9",  -- 146 
    "13sus#9",  -- 147 
    "7sus#9b13",  -- 148 
    "9sus#11",  -- 149 
    "13sus#9#11",  -- 150 
    "7sus#9#11b13",  -- 151 
    "7susb5",  -- 152 
    "13susb5",  -- 153 
    "7susb5b13",  -- 154 
    "9susb5",  -- 155 
    "9susb5b13",  -- 156 
    "7susb5b9",  -- 157 
    "13susb5b9",  -- 158 
    "7susb5b9b13",  -- 159 
    "7susb5#9",  -- 160 
    "13susb5#9",  -- 161 
    "7susb5#9b13",  -- 162 
    "7sus#5",  -- 163 
    "13sus#5",  -- 164 
    "7sus#5#11",  -- 165 
    "13sus#5#11",  -- 166 
    "9sus#5",  -- 167 
    "9sus#5#11",  -- 168 
    "7sus#5b9",  -- 169 
    "13sus#5b9",  -- 170 
    "7sus#5b9#11",  -- 171 
    "13sus#5b9#11",  -- 172 
    "7sus#5#9",  -- 173 
    "13sus#5#9#11",  -- 174 
    "7sus#5#9#11",  -- 175 
    "13sus#5#9#11",  -- 176 
    "4",  -- 177 
    "?",  -- 178 
    "?",  -- 179 
    "?",  -- 180 
    "?",  -- 181 
    "?",  -- 182 
    "?",  -- 183 
    "sus"}  -- 184 
    
  retval = reaper.MB( "Yes the Song 4/4 or No for 3/4", "Time Signature", 4 ) 
  if retval == 6 then
    chords_44()
  end
  if retval == 7 then
    chords_34()
  end     
  
end

function btn_delete_regions()

  commandID1 = reaper.NamedCommandLookup("_SWSMARKERLIST10")
  reaper.Main_OnCommand(commandID1, 0) -- SWS: Delete all regions
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end


function round(val, decimal)
  local exp = decimal and 10^decimal or 1
  return math.ceil(val * exp - 0.5) / exp
end


function GetFilename(path)   
    local start, finish = path:find('[%w%s!-={-|]+[_%.].+')   
    return path:sub(start,#path) 
end 

function chords_34()
    retval, filetxt = reaper.GetUserFileNameForRead("", "Import Chords from SGU,MGU...", "")
    
    --print(GetFilename(filetxt))
    
    f = assert(io.open(filetxt, "rb"))
    
    local first_byte_sig = f:read(1)
    local name_bytes = f:read(1)
    --print("First byte = "..tostring(first_byte_sig))
    name_len = string.byte(name_bytes)
    --print("Name_length =" ..name_len)
    local bytes = f:read(name_len)
    --print("Name: "..tostring(bytes))
    local meter_denominator = 4
    --print("Meter: "..tostring(4).."/"..tostring(meter_denominator))
    local byte1 = string.byte(f:read(1))
    local byte2 = string.byte(f:read(1))
    local byte3 = string.byte(f:read(1))
    local keyByte = string.byte(f:read(1)) --read 
    local tempoByte = string.byte(f:read(1)) --read tempo byte
    
    if keyByte <= 17 then
      key = rootNames[keyByte]
      isMinor = false 
    else key = rootNames[keyByte - 17]
      isMinor = true
    end
    if isMinor then
      --print("Key : " ..key.. "m")
    else --print("Key: " ..key)
    end
    --print("Tempo: " ..tempoByte)
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    reaper.SetCurrentBPM( 0, tempoByte, 0 ) -- 0 no undo points 1 undo points
    
    
    reaper.SetTempoTimeSigMarker( 0, -1, 0, -1, -1, -1, 3, 4, false )
    
    local bar = string.byte(f:read(1)) --read start bar number
    --print("Start bar: " ..bar)
    
    local types = {}
    local roots = {}
    local beats = {}
    local partm = {}
    numberOfChords = 1

-- count through the bars and bar types to find section boundaries
    
    while bar < 255 do -- maximum of 255 bars
      local barType = string.byte(f:read(1)) --read bar type
      
      if barType == 0 then
        duration = string.byte(f:read(1))
        bar = bar + duration
      else bar = bar + 1
      end
    

      partm[bar] = barType
       
    end
    
    total_bars = bar - duration -1
    --print("Total number of bars =" ..total_bars)
-- count through the chord type/duration section recording the beat count where chord changes occur in table beats[] and the chord type in types[] 
    local beat = 1 --start at beat 1
    while beat < 1020 do --maximum of 1020 beats (= 255 bars x 4 beats)
      local chordType = string.byte(f:read(1))
      if chordType == 0 then
        local duration = string.byte(f:read(1))
        beat = beat + duration
      else types[numberOfChords] = chordType
        --print("Chord change number "..tostring(numberOfChords).." to "..tostring(chordType).." ["..typeNames[chordType].."] at beat count "..tostring(beat))
        beats[numberOfChords] = beat
        numberOfChords = numberOfChords + 1
        last_beat = beat
        beat = beat + 1
      end
    end
  total_beats = last_beat - 1


  local i=1
  beat = 1 --start at beat 1
  
  while beat < 1020 do --maximum of 1020 beats
    
    local chordRoot = string.byte(f:read(1))
    if chordRoot == 0 then 
      local duration = string.byte(f:read(1))
      beat = beat + duration
    else roots[i] = chordRoot
      if beat ~= beats[i] then
        --print("Inconsistent chord type and root beat")
      end
      

      i = i + 1
      beat = beat + 1
    end
 
  end


  if i ~= numberOfChords then
    print("Inconsistent number of chord types and roots")
  end


  beats_no = (last_beat +15) / 4 * 3
  --print("Toatal 3/4 Beats ".. beats_no  )
  waltz_bars = 0
  
  
  chord_name = {}
  beat_count = {}
  part_marker = {}
  part_marker_beats = {}
  
  for i = 1, tablelength(roots)  do
  
    waltz_beats = ((beats[i] / 4) * 3) +.75 --+.25 
    beat_number = 1
    --print("waltz_beats ".. waltz_beats)
    
    
    waltz_bars = (waltz_beats / 3) + .66666666666667
    --if waltz_bars ~= math.floor(waltz_bars) then
      
      waltz_bars2 = round(waltz_bars,0)
      --print("waltz_bars ".. waltz_bars .." floor ".. waltz_bars2)
      if tostring(waltz_bars2) == tostring(waltz_bars) then
        beat_number = 1 --print("Is Equal")
      
      elseif waltz_bars2 < waltz_bars then
        beat_number = 2 --print("Is Less")
       
      elseif waltz_bars2 > waltz_bars then 
        beat_number = 3 --print("Is Greater")
      end 
     
     waltz_beats2 = math.floor(waltz_beats)
     
     
  --end
   --print("Beat ".. waltz_beats2 .." Bar ".. math.floor(waltz_bars) .."[" .. beat_number .."]".." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
 
  --end
  

  
  
    --print("Beat ".. waltz_beats2 .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
    
    chord_name[i] = tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]])
    beat_count[i] = waltz_beats2
    
  
  end
  

  
  part_marker_count = 0
  for i = 2, total_bars +1 do --tablelength(roots) do --total_bars +1 do
    if partm[i] and partm[i] > 0 then
      --print("PartM ".. (i*3 )-5  .. " " ..tostring(partm[i]))
      part_marker[i] = tostring(partm[i])
      part_marker_beats[i] = (i*3 )-5
    end
    part_marker_count = part_marker_count +1
  end   
  
  for i = 1, part_marker_count +1 do
    if part_marker_beats[i] then
      --print("part_marker_beats ".. part_marker_beats[i] .." type ".. part_marker[i])
    --print("beat_count ".. beat_count[3] .." ".. chord_name[3])
  
    --print("Toatal Bars ".. total_bars+3)
    end
  end
  
  for i = 1, tablelength(roots) +1 do --total_bars +1 do
  
    --chord_name[i]
    --beat_count[i]
    
    for m = 1, part_marker_count +1 do
      if part_marker_beats[m] then
        --print("PM Color ".. beat_count[i] .." ".. part_marker_beats[m])
        if beat_count[i] == part_marker_beats[m] then
          --print("FOUND part_marker_beats ".. part_marker_beats[m])
          if part_marker[m] == "1" then
            --print("BLUE")
            color = reaper.ColorToNative(55,118,235)|0x1000000
          end
          if part_marker[m] == "2" then
            --print("GREEN")
            color = reaper.ColorToNative(17,174,59)|0x1000000
          end      
        end
      end  
      
    end  
    
    if beat_count[i] then
      --print("REG START beat_count[i] ".. beat_count[i] .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
      reg_start = reaper.TimeMap2_beatsToTime( 0, beat_count[i]+5 )
      reg_start = reaper.SnapToGrid( 0, reg_start )
      --print("TIME reg_start "..reg_start)
    end  
    --reg_start = reaper.SnapToGrid( 0, reg_start )
    --print("reg_start "..reg_start)
   
    -- ADD 2 bar for count-in
    if i < tablelength(roots) then
      --print("REG END beat_count[i] ".. beat_count[i+1])
      reg_end = reaper.TimeMap2_beatsToTime( 0, beat_count[i+1]+5 )
      reg_end = reaper.SnapToGrid( 0, reg_end )
      --print("TIME reg_end "..reg_end)
      reaper.AddProjectMarker2( 0, true, reg_start, reg_end, chord_name[i], 1, color )
    end
    if i == tablelength(roots) then
      ending_bars = reaper.TimeMap2_beatsToTime( 0, 12)
      ending_bars = reaper.SnapToGrid( 0, ending_bars )
      reaper.AddProjectMarker2( 0, true, reg_start, reg_start+ending_bars, chord_name[i], 1, color )
    end
  end
  
  --reaper.Main_OnCommand( 40898, 0 ) -- Markers: Renumber all markers in timeline order
  reaper.SNM_SetIntConfigVar( "projmeasoffs", -2) -- offset measures
  
  
  
end  

function chords_44()
    retval, filetxt = reaper.GetUserFileNameForRead("", "Import Chords from SGU,MGU...", "")
    
    --print(GetFilename(filetxt))
    
    f = assert(io.open(filetxt, "rb"))
    
    local first_byte_sig = f:read(1)
    local name_bytes = f:read(1)
    --print("First byte = "..tostring(first_byte_sig))
    name_len = string.byte(name_bytes)
    --print("Name_length =" ..name_len)
    local bytes = f:read(name_len)
    --print("Name: "..tostring(bytes))
    local meter_denominator = 4
    --print("Meter: "..tostring(4).."/"..tostring(meter_denominator))
    local byte1 = string.byte(f:read(1))
    local byte2 = string.byte(f:read(1))
    local byte3 = string.byte(f:read(1))
    local keyByte = string.byte(f:read(1)) --read 
    local tempoByte = string.byte(f:read(1)) --read tempo byte
    
    if keyByte <= 17 then
      key = rootNames[keyByte]
      isMinor = false 
    else key = rootNames[keyByte - 17]
      isMinor = true
    end
    if isMinor then
      --print("Key : " ..key.. "m")
    else --print("Key: " ..key)
    end
    --print("Tempo: " ..tempoByte)
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    reaper.SetCurrentBPM( 0, tempoByte, 0 ) -- 0 no undo points 1 undo points
    
    
    --reaper.SetTempoTimeSigMarker( 0, -1, 0, -1, -1, -1, 4, 4, false )
    
    local bar = string.byte(f:read(1)) --read start bar number
    --print("Start bar: " ..bar)
    
    local types = {}
    local roots = {}
    local beats = {}
    local partm = {}
    numberOfChords = 1

-- count through the bars and bar types to find section boundaries
    
    while bar < 255 do -- maximum of 255 bars
      local barType = string.byte(f:read(1)) --read bar type
      
      if barType == 0 then
        duration = string.byte(f:read(1))
        bar = bar + duration
      else bar = bar + 1
      end
    

      partm[bar] = barType
       
    end
    
    total_bars = bar - duration -1
    --print("Total number of bars =" ..total_bars)
-- count through the chord type/duration section recording the beat count where chord changes occur in table beats[] and the chord type in types[] 
    local beat = 1 --start at beat 1
    while beat < 1020 do --maximum of 1020 beats (= 255 bars x 4 beats)
      local chordType = string.byte(f:read(1))
      if chordType == 0 then
        local duration = string.byte(f:read(1))
        beat = beat + duration
      else types[numberOfChords] = chordType
        --print("Chord change number "..tostring(numberOfChords).." to "..tostring(chordType).." ["..typeNames[chordType].."] at beat count "..tostring(beat))
        beats[numberOfChords] = beat
        numberOfChords = numberOfChords + 1
        last_beat = beat
        beat = beat + 1
      end
    end
  total_beats = last_beat - 1


  local i=1
  beat = 1 --start at beat 1
  
  while beat < 1020 do --maximum of 1020 beats
    
    local chordRoot = string.byte(f:read(1))
    if chordRoot == 0 then 
      local duration = string.byte(f:read(1))
      beat = beat + duration
    else roots[i] = chordRoot
      if beat ~= beats[i] then
        --print("Inconsistent chord type and root beat")
      end
      

      i = i + 1
      beat = beat + 1
    end
 
  end


  if i ~= numberOfChords then
    print("Inconsistent number of chord types and roots")
  end


  beats_no = (last_beat +15) / 4 * 4
  --print("Toatal 3/4 Beats ".. beats_no  )
  waltz_bars = 0

  
    --types = {}
    --roots = {}
    --beats = {}
    --partm = {}  
  
  chord_name = {}
  beat_count = {}
  part_marker = {}
  part_marker_beats = {}
  
  for i = 1, tablelength(roots) do
  
    nom_beats = beats[i] --((beats[i] / 4) * 4) 
    beat_number = 1
    
    nom_bars = (nom_beats / 4) 
    
    nom_bars  = math.floor(nom_bars)
    --nom_bars2 = round(nom_bars,0)
     
     
    nom_beats2 = math.floor(nom_beats)
     
    --print("BAR ".. math.floor(nom_beats2 /4))
    --end
    --print("Beat ".. nom_beats2 .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
    
    chord_name[i] = tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]])
    beat_count[i] = nom_beats2
    
  
  end
  part_marker_count = 0
  for i = 2, total_bars +1 do --tablelength(roots) do --total_bars +1 do
    if partm[i] and partm[i] > 0 then
      --print("PartM ".. (i*4 )-7  .. " " ..tostring(partm[i]))
      part_marker[i] = tostring(partm[i])
      part_marker_beats[i] = (i*4 )-7
    end
    part_marker_count = part_marker_count +1
  end   
  
  for i = 1, part_marker_count +1 do
    if part_marker_beats[i] then
      --print("part_marker_beats ".. part_marker_beats[i] .." type ".. part_marker[i])
    --print("beat_count ".. beat_count[3] .." ".. chord_name[3])

    --print("Toatal Bars ".. total_bars+3)
    end
  end
  
  for i = 1, tablelength(roots) +1 do --total_bars +1 do
  
    --chord_name[i]
    --beat_count[i]
    
    for m = 1, part_marker_count +1 do
      if part_marker_beats[m] then
        --print("PM Color ".. beat_count[i] .." ".. part_marker_beats[m])
        if beat_count[i] == part_marker_beats[m] then
          --print("FOUND part_marker_beats ".. part_marker_beats[m])
          if part_marker[m] == "1" then
            --print("BLUE")
            color = reaper.ColorToNative(55,118,235)|0x1000000
          end
          if part_marker[m] == "2" then
            --print("GREEN")
            color = reaper.ColorToNative(17,174,59)|0x1000000
          end      
        end
      end  
      
    end  
    
    if beat_count[i] then
      reg_start = reaper.TimeMap2_beatsToTime( 0, beat_count[i]+7 )
    end  
    reg_start = reaper.SnapToGrid( 0, reg_start )
    --print("reg_start "..reg_start)
   
    -- ADD 2 bar for count-in
    if i < tablelength(roots) then
      reg_end = reaper.TimeMap2_beatsToTime( 0, beat_count[i+1]+7 )
      reg_end = reaper.SnapToGrid( 0, reg_end )
      --print("reg_end "..reg_end)
      reaper.AddProjectMarker2( 0, true, reg_start, reg_end, chord_name[i], 1, color )
    end
    if i == tablelength(roots) then
      ending_bars = reaper.TimeMap2_beatsToTime( 0, 16)
      ending_bars = reaper.SnapToGrid( 0, ending_bars )
      reaper.AddProjectMarker2( 0, true, reg_start, reg_start+ending_bars, chord_name[i], 1, color )
    end
  end
  
  --reaper.Main_OnCommand( 40898, 0 ) -- Markers: Renumber all markers in timeline order
  reaper.SNM_SetIntConfigVar( "projmeasoffs", -2) -- offset measures
  
end


reaper.MB( "Click Rewire Settings Button to Set Rewire Settings to Ignore tempo map...", "Set Rewire Info", 0 )
reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/reaper_rewire.ahk]],-2)
------------------------------------
-------- Window settings -----------
------------------------------------


GUI.name = "Biab Rewire Control"
GUI.x, GUI.y, GUI.w, GUI.h = 0, 0, 400, 350
GUI.anchor, GUI.corner = "mouse", "C"



------------------------------------
-------- GUI Elements --------------
------------------------------------


--[[     

  Button          z,      x,      y,      w,      h, caption, func[, ...]
  Checklist     z,      x,      y,      w,      h, caption, opts[, dir, pad]
  Menubox          z,      x,      y,      w,      h, caption, opts, pad, noarrow]
  Slider          z,      x,      y,      w,      caption, min, max, defaults[, inc, dir]
  
]]--

--GUI.New("mnu_mode",     "Menubox",          1, 64,     32,  72, 20, "Mode:", "Auto,Punch,Step")
--GUI.New("chk_opts",     "Checklist",     1, 192,     32,  192, 96, "Options", "Only in time selection,Only on selected track,Glue items when finished", "v", 4)
--GUI.New("sldr_thresh", "Slider",     1, 32,  96, 128, "Threshold", -60, 0, 48, nil, "h")
--GUI.New("btn_up",     "Button",          1, 128, 202, 64, 24, "+", btn_click_up)
--GUI.New("btn_down",     "Button",          1, 208, 202, 64, 24, "-", btn_click_down)

--GUI.New("my_label", "Label", 1, 32, 62, "Send Commands to Biab")

GUI.New("lb_biab",      "Label",           3, 10, 10, "Send to Biab", true, 1, "verse_fill", "wnd_bg" )
GUI.elms.lb_biab.font = {"Arial", 20, "bi"}

GUI.New("btn_play",     "Button",          1, 10, 40, 74, 24, "Play/Stop", btn_click_play)
GUI.elms.btn_play.col_txt = "white"
GUI.elms.btn_play.col_fill = "chorus_post_fill"

GUI.New("btn_play_from",     "Button",          1, 90, 40, 114, 24, "Play From Cursor", btn_play_from)
GUI.elms.btn_play_from.col_txt = "white"
GUI.elms.btn_play_from.col_fill = "chorus_post_fill"

GUI.New("btn_play_bb_loop",     "Button",          1, 210, 40, 94, 24, "Play Biab Loop", btn_play_bb_loop)
GUI.elms.btn_play_bb_loop.col_txt = "white"
GUI.elms.btn_play_bb_loop.col_fill = "chorus_post_fill"

GUI.New("btn_play_start",     "Button",          1, 310, 40, 74, 24, "Play Start", btn_play_start)
GUI.elms.btn_play_start.col_txt = "white"
GUI.elms.btn_play_start.col_fill = "chorus_post_fill"

GUI.New("btn_play_reaper_loop",     "Button",          1, 10, 80, 114, 24, "Play Reaper Loop", btn_play_reaper_loop)
GUI.elms.btn_play_reaper_loop.col_txt = "white"
GUI.elms.btn_play_reaper_loop.col_fill = "chorus_post_fill"

GUI.New("btn_stop",     "Button",          1, 130, 80, 40, 24, "Stop", btn_stop)
GUI.elms.btn_stop.col_txt = "white"
GUI.elms.btn_stop.col_fill = "red"

GUI.New("btn_clear_bb_loop",     "Button",          1, 175, 80, 94, 24, "Clear Biab Loop", btn_clear_bb_loop)
GUI.elms.btn_clear_bb_loop.col_txt = "white"
GUI.elms.btn_clear_bb_loop.col_fill = "intro_post_fill"

GUI.New("btn_bb_save",     "Button",          1, 10, 120, 114, 24, "Save Biab Song", btn_bb_save)
GUI.elms.btn_bb_save.col_txt = "white"
GUI.elms.btn_bb_save.col_fill = "shot"

GUI.New("btn_bb_save_as",     "Button",          1, 130, 120, 114, 24, "Save Biab Song As", btn_bb_save_as)
GUI.elms.btn_bb_save_as.col_txt = "white"
GUI.elms.btn_bb_save_as.col_fill = "shot"

v=10 --Vertcal position offset for Reaper Commands


GUI.New("lb_reaper",      "Label",           3, 10, 170+v, "Send to Reaper", true, 1, "verse_fill", "wnd_bg" )
GUI.elms.lb_reaper.font = {"Arial", 20, "bi"}

GUI.New("btn_set_countin",     "Button",          1, 10, 200+v, 114, 24, "Set 2 Bar Count-In", btn_set_countin)
GUI.elms.btn_set_countin.col_txt = "white"
GUI.elms.btn_set_countin.col_fill = "shot"

GUI.New("btn_copy_bb_tempo",     "Button",          1, 130, 200+v, 114, 24, "Set to Biab Tempo", btn_copy_bb_tempo)
GUI.elms.btn_copy_bb_tempo.col_txt = "white"
GUI.elms.btn_copy_bb_tempo.col_fill = "shot"

GUI.New("btn_reaper_rewire",     "Button",          1, 250, 200+v, 114, 24, "Rewire Settings", btn_reaper_rewire)
GUI.elms.btn_reaper_rewire.col_txt = "white"
GUI.elms.btn_reaper_rewire.col_fill = "shot"

GUI.New("btn_delete_regions",     "Button",          1, 10, 240+v, 114, 24, "Delete All Chords", btn_delete_regions)
GUI.elms.btn_delete_regions.col_txt = "white"
GUI.elms.btn_delete_regions.col_fill = "shot"

GUI.New("btn_import_sgu",     "Button",          1, 130, 240+v, 114, 24, "Import SGU Chords", btn_import_sgu)
GUI.elms.btn_import_sgu.col_txt = "white"
GUI.elms.btn_import_sgu.col_fill = "shot"

GUI.New("btn_reaper_save",     "Button",          1, 250, 240+v, 114, 24, "Save Reaper Song", btn_reaper_save)
GUI.elms.btn_reaper_save.col_txt = "white"
GUI.elms.btn_reaper_save.col_fill = "shot"

GUI.New("btn_reaper_save_as",     "Button",          1, 10, 280+v, 124, 24, "Save Reaper Song As", btn_reaper_save_as)
GUI.elms.btn_reaper_save_as.col_txt = "white"
GUI.elms.btn_reaper_save_as.col_fill = "shot"

GUI.New("btn_clear_repaer_loop",     "Button",          1, 250, 280+v, 114, 24, "Clear Reaper Loop", btn_clear_repaer_loop)
GUI.elms.btn_clear_repaer_loop.col_txt = "white"
GUI.elms.btn_clear_repaer_loop.col_fill = "intro_post_fill"


--GUI.New("my_txt",   "Textbox",     1, 50, 130, 120, 20, "Text:", 4)

--GUI.Val("my_txt") --Returns the contents of the textbox.
--GUI.Val("my_txt", "Hello, world!") --Sets the contents of the textbox.

GUI.func = Main

-- How often (in seconds) to run GUI.func. 0 = every loop.
GUI.freq = 1

GUI.Init()
GUI.Main()

